<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * A class with all basic methods to preform some actions
 *
 * @package		Default module
 * @category	Modules
 * @author		Rein de Vries <info@reinos.nl>
 * @link		http://reinos.nl
 * @copyright 	Copyright (c) 2013 Reinos.nl Internet Media
 */
 
/**
 * Include the config file
 */
require_once PATH_THIRD.'entry_trash/config.php';

class Entry_trash_actions {
		
	private $EE;
	
	// ----------------------------------------------------------------------
	
	/**
	 * Constructor
	 */
	public function __construct()
	{
		//load the Classes
		$this->EE =& get_instance();
		
		//load default helper
		$this->EE->load->library(ENTRY_TRASH_MAP.'_library');

		//require the default settings
		require PATH_THIRD.ENTRY_TRASH_MAP.'/settings.php';

	}

	// ----------------------------------------------------------------
	
	/**
	 * add_entry_to_trash
	 *
	 * @param none
	 * @return void
	 */
	public function add_entry_to_trash($entry_id = 0, $table = '', $entry_id_field = '')
	{
		$this->EE->entry_trash_library->add_entry_to_trash($entry_id, $table, $entry_id_field);
	}

	// ----------------------------------------------------------------
	
	/**
	 * restore_entry_from_trash
	 *
	 * @param none
	 * @return void
	 */
	public function restore_entry_from_trash($entry_id = 0)
	{
		$this->EE->entry_trash_library->restore_entry_from_trash($entry_id);
	}

	// ----------------------------------------------------------------
	
	/**
	 * test_restore_entry_from_trash
	 *
	 * @param none
	 * @return void
	 */
	public function test_restore_entry_from_trash($entry_id = 0)
	{
		return $this->EE->entry_trash_library->test_restore_entry_from_trash($entry_id);
	}

	// ----------------------------------------------------------------
	
	/**
	 * delete_entry_from_trash
	 *
	 * @param none
	 * @return void
	 */
	public function delete_entry_from_trash($entry_id = 0)
	{
		$this->EE->entry_trash_library->delete_entry_from_trash($entry_id);
	}

	// ----------------------------------------------------------------

}


/* End of file mod.entry_trash.php */
/* Location: /system/expressionengine/third_party/entry_trash/mod.entry_trash.php */