<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * Default Model
 *
 * @package		Default name
 * @category	Modules
 * @author		Rein de Vries <info@reinos.nl>
 * @link		http://reinos.nl
 * @copyright 	Copyright (c) 2013 Reinos.nl Internet Media
 */

/**
 * Include the config file
 */
require_once PATH_THIRD.'entry_trash/config.php';

class Entry_trash_model
{

	private $EE;

	public function __construct()
	{							
		// Creat EE Instance
		$this->EE =& get_instance();
	}

	// ----------------------------------------------------------------------

	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function add_entry_to_trash($entry_id = 0, $table = '', $entry_id_field = 'entry_id', $data = '')
	{
		if($entry_id != 0 && $table != '')
		{
			//get existing data?
			//$this->EE->db->where('entry_id', $entry_id);
			//$this->EE->db->where('table', $table);
			//$this->EE->db->from(ENTRY_TRASH_MAP.'_items');
			//$q = $this->EE->db->get();

			//there can`t be a duplicated entry
			//insert only when there is no data for this entry in combination with the table 
			//if($q->num_rows() == 0)
			//{
				$this->EE->db->insert(ENTRY_TRASH_MAP.'_items',
				array(
					'site_id' => $this->EE->config->item('site_id'),
					'entry_id' => $entry_id,
					'entry_id_field' => $entry_id_field,
					'table' => $table,
					'data' => serialize($data)
				));
			//}
		}
	}

	// ----------------------------------------------------------------------
	
	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function restore_entry_from_trash()
	{

	}

	// ----------------------------------------------------------------------
	
	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function delete_entry_from_trash($entry_id = 0)
	{
		//delete all data associated with the entry_id
		$this->EE->db->delete(ENTRY_TRASH_MAP.'_items', array(
			'entry_id' => $entry_id
		));
	}

	// ----------------------------------------------------------------------
	
	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function entry_exists($entry_id = 0, $table = '')
	{
		//get the data
		$this->EE->db->where('entry_id', $entry_id);
		$this->EE->db->from($table);
		$q = $this->EE->db->get();

		if($q->num_rows() > 0) 
		{
			return true;
		}
		else
		{
			return false;
		}

	}

	// ----------------------------------------------------------------------
	
	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function get_trash($entry_id = 0)
	{
		//get the data
		$this->EE->db->where('entry_id', $entry_id);
		$this->EE->db->from(ENTRY_TRASH_MAP.'_items');
		return $this->EE->db->get();

	}

	// ----------------------------------------------------------------------
	
	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function count_trash()
	{
		$this->EE->db->group_by('entry_id');
		$this->EE->db->from(ENTRY_TRASH_MAP.'_items');
		$q = $this->EE->db->get();
		return $q->num_rows();
	}

	// ----------------------------------------------------------------------
	
	/**
	 * 
	 *
	 * @param none
	 * @return void
	 */
	public function get_all_trash($entry_id = '', $start = 0, $limit = false, $order = array())
	{

		$trash = array();
		$q = '';

		//get all trash for an specific site_id
		if($entry_id == '')
		{
			$this->EE->db->select('*');
			$this->EE->db->from(ENTRY_TRASH_MAP.'_items');
		}

		//Fetch a list of entries in array
		else if(is_array($entry_id) && !empty($entry_id))
		{
			$this->EE->db->select('*');
			$this->EE->db->from(ENTRY_TRASH_MAP.'_items');
			$this->EE->db->where_in('entry_id', $entry_id);
		}

		//fetch only the alias for an entry_id
		else if(!is_array($entry_id))
		{
			$this->EE->db->select('*');
			$this->EE->db->from(ENTRY_TRASH_MAP.'_items');
			$this->EE->db->where('entry_id', $entry_id);
		}

		//do nothing
		else
		{
			return array();
		}

		//is there a start and limit
		if($limit !== false)
		{
			$this->EE->db->limit($start, $limit);
		}

		//do we need to order
		//given by the mcp table method http://ellislab.com/expressionengine/user-guide/development/usage/table.html
		if(!empty($order))
		{
			if(isset($order['entry_trash_title']))
			{
				$this->EE->db->order_by('current_path', $order['entry_trash_title']);	
			}
			if(isset($order['entry_trash_channel']))
			{
				$this->EE->db->order_by('alias_path', $order['entry_trash_channel']);	
			}
		}

		//default where
		$this->EE->db->where('site_id', $this->EE->config->item('site_id'));
		$this->EE->db->where('table', 'channel_titles');
		
		//get the result
		$q = $this->EE->db->get();

		//format result
		if($q != '' && $q->num_rows() > 0)
		{
			foreach($q->result() as $key=>$val)
			{
				$trash[$key] = unserialize($val->data);

				//get the channel name and id
				if(isset($trash[$key]))
				{
					$trash[$key]->channel_data = $this->get_channel_data($trash[$key]->channel_id, array('channel_name', 'channel_title'));
				}
			}
		}

		return $trash;
	}

	// ----------------------------------------------------------------------
	
	/**
	 * Get the channels
	 *
	 * @param none
	 * @return void
	 */
	public function get_channels()
	{
		//fetch the channels
        $channels_sql = $this->EE->db->select('channel_id, channel_title, channel_name')->from('channels')->get()->result_array();
        $channels = array();
        if(!empty($channels_sql))
        {
            foreach($channels_sql as $val)
            {
                $channels[$val['channel_id']] = $val['channel_title'];
            }
        }

        return $channels;
	}

	// ----------------------------------------------------------------------
	
	/**
	 * Get channel ID for entry_id
	 *
	 * @param none
	 * @return void
	 */
	public function get_channel_id_for_entry_id($entry_id = 0)
	{
		//fetch the channels
        $this->EE->db->select('channel_id');
        $this->EE->db->from('channel_titles');
        $this->EE->db->where('entry_id', $entry_id);
        $result = $this->EE->db->get();

        if($result->num_rows > 0)
        {
        	return $result->row()->channel_id; 
        }
        
        false; 
	}

	// ----------------------------------------------------------------------
	
	/**
	 * Get the channel_name and channel_title
	 *
	 * @param none
	 * @return void
	 */
	public function get_channel_data($channel_id = 0, $fields = array('*'))
	{
		$this->EE->db->select(implode(',', $fields));
		$this->EE->db->from('channels');
		$this->EE->db->where('channel_id', $channel_id);
		$q = $this->EE->db->get();

		if($q->num_rows() > 0)
		{
			return $q->row();
		}
	}
	

} // END CLASS

/* End of file default_model.php  */
/* Location: ./system/expressionengine/third_party/entry_trash/models/entry_trash_model.php */