<?php

class Entry_trash_example_ext {

    var $name           = 'Entry Trash Example';
    var $version        = '1.0b';
    var $description    = 'Example how the Entry Trash can be implement for other add-ons';
    var $settings_exist = 'n';
    var $docs_url       = 'http://reinos.nl/add-ons/entry-trash';

    var $settings       = array();

    /**
     * Constructor
     *
     * @param   mixed   Settings array or empty string if none exist.
     */
    function __construct($settings = '')
    {
        $this->EE =& get_instance();

        $this->settings = $settings;
    }

    /**
    * Activate Extension
    *
    * This function enters the extension into the exp_extensions table
    *
    * @see http://codeigniter.com/user_guide/database/index.html for
    * more information on the db class.
    *
    * @return void
    */
    function activate_extension()
    {
        $data = array(
            'class'     => __CLASS__,
            'method'    => 'entry_trash_add_to_trash',
            'hook'      => 'entry_trash_add_to_trash',
            'settings'  => serialize($this->settings),
            'priority'  => 10,
            'version'   => $this->version,
            'enabled'   => 'y'
        );

        $this->EE->db->insert('extensions', $data);
    }

    /**
    * Update Extension
    *
    * This function performs any necessary db updates when the extension
    * page is visited
    *
    * @return  mixed   void on update / false if none
    */
    function update_extension($current = '')
    {
        if ($current == '' OR $current == $this->version)
        {
            return FALSE;
        }

        $this->EE->db->where('class', __CLASS__);
        $this->EE->db->update(
            'extensions',
            array('version' => $this->version)
        );
    }

    /**
    * Disable Extension
    *
    * This method removes information from the exp_extensions table
    *
    * @return void
    */
    function disable_extension()
    {
        $this->EE->db->where('class', __CLASS__);
        $this->EE->db->delete('extensions');
    }

    /**
    * entry_trash_add_to_trash method
    *
    * This method will be called by the entry_trash module
    *
    * @param int $entry_id
    * @param object $entry_trash 
    * @return void
    */
    function entry_trash_add_to_trash($entry_id, $entry_trash)
    {
        // Add data to the trash
        // @param $entry_id; is the id of an entry or references to an entry
        // @param $table; is the table name where the record stays. The entry_trash module will get it from there by himself
        $entry_trash->add_entry_to_trash($entry_id, 'your_table');
        $entry_trash->add_entry_to_trash($entry_id, 'your_second_table');
    }

    /**
    * entry_trash_delete_from_trash method
    *
    * This method will be called by deleting a entry from the trash
    *
    * @param int $entry_id
    * @return void
    */
    function entry_trash_delete_from_trash($entry_id, $associated_data)
    {
        //preform your handlings for your module
    }

    /**
    * entry_trash_restore_from_trash method
    *
    * This method will be called by restoring a entry from the trash
    *
    * @param int $entry_id
    * @return void
    */
    function entry_trash_restore_from_trash($new_entry_id, $old_entry_id)
    {
        //preform your handlings for your module
    }

}
// END CLASS